<?
sapp_include_once('common.php');

function better_srand($seed = '') {
    static $wascalled = FALSE;
    if (!$wascalled) {
        if ($seed === '') {
            list($usec, $sec) = explode(" ", microtime());
            if ($usec > 0.1)
                $seed = (double) $usec * $sec;
            else // once in a while use the combined LCG entropy
                $seed = (double) 1000000 * substr(uniqid("", true), 13);
        }
        if (function_exists('mt_srand')) {
            mt_srand($seed); // mersenne twister
        } else {
            srand($seed);
        }
        $wascalled = TRUE;
    }
}

function rand_ascii($length = 1) {
    better_srand();
    $s = "";
    for ($i = 1; $i <= $length; $i++) {
    // return only typeable 7 bit ascii, avoid quotes
        if (function_exists('mt_rand'))
    	    // the usually bad glibc srand()
            $s .= chr(mt_rand(40, 126));
        else
            $s .= chr(rand(40, 126));
    }
    return $s;
}

function admin_passwd_crypt($pass){
    if (function_exists('crypt')) {
        $salt_length = max(CRYPT_SALT_LENGTH,
			    2 * CRYPT_STD_DES,
                            9 * CRYPT_EXT_DES,
			    12 * CRYPT_MD5,
			    16 * CRYPT_BLOWFISH);
	// generate an encrypted password
	$crypt_pass = crypt($pass, rand_ascii($salt_length));
	return $crypt_pass;
    } else {
	return $pass;
    }
}


function form_handler()
{
    $valid = true;

    
	// Check admin_login
	$admin_login = sapp_get_submit_value('admin_login');
        if (!check_sys_login($admin_login)){
            sapp_set_wrong('admin_login', msg('warning_about_login_syntax'));
            $valid = false;
        }
        sapp_set_param('admin_login', $admin_login);

        //check admin password
        $admin_passwd = sapp_get_submit_value('admin_passwd');
        $admin_passwd_confirm = sapp_get_submit_value('admin_passwd_confirm');

        if ('' == $admin_passwd) {
            if (!sapp_get_param('admin_passwd')) {
                sapp_set_wrong('admin_passwd', msg('password__empty'));
                $valid = false;
            } else {
                $admin_passwd = sapp_get_param('admin_passwd');
            }
        } elseif ($admin_passwd != $admin_passwd_confirm) {
            sapp_set_wrong('admin_passwd', msg('password__not_match'));
            sapp_set_wrong('admin_passwd_confirm', msg('password__not_match'));
            $valid = false;
        } elseif (!check_sys_passwd('', $admin_passwd)) {
            sapp_set_wrong('admin_passwd', msg('warning_about_passwd_syntax'));
            $valid = false; 
        } else {
            sapp_set_param('admin_passwd', admin_passwd_crypt($admin_passwd));                
        }


        //check language
        $language = sapp_get_submit_value('language');
        sapp_set_param('language', $language);
																				


    if (!$valid) {
        sapp_set_error(msg('invalid_values'));
        return 1;
    }

    return 2;
}
?>
